/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author cteam040
 */
import java.util.*;
import java.io.*;

public class rhino {

    public static Comparator<Card> BY_VALUE = new Comparator<Card>(){

        public int compare(Card arg0, Card arg1) {
            return arg0.val.ordinal()-arg1.val.ordinal();
        }
    };
    public static Comparator<Card> BY_COLOR = new Comparator<Card>(){

        public int compare(Card arg0, Card arg1) {
            return arg0.col.ordinal()-arg1.col.ordinal();
        }
    };
    
    public static void main(String args[]) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer st;
        String ln = null;
        while ((ln = br.readLine()) != null) {
            int nplayers = Integer.parseInt(ln);
            st = new StringTokenizer(br.readLine());
            final List<Card> table = Arrays.asList(Card.fromStr(st.nextToken()), Card.fromStr(st.nextToken()), Card.fromStr(st.nextToken()), Card.fromStr(st.nextToken()), Card.fromStr(st.nextToken()));
            ;
            List<Player> pls = new ArrayList<Player>(nplayers);
            for (int i = 0; i < nplayers; i++) {
                st = new StringTokenizer(br.readLine());
                Player pl = new Player();
                pl.cards.addAll(table);
                pl.cards.add(Card.fromStr(st.nextToken()));
                pl.cards.add(Card.fromStr(st.nextToken()));
                Collections.sort(pl.cards,BY_VALUE);
                pl.cards_col = new ArrayList<Card>(pl.cards);
                Collections.sort(pl.cards_col,BY_COLOR);
                pls.add(i, pl);

            }
            for(Player p:pls)
            {
                System.out.println(p);
                System.out.println(p.isRoFlush());
                System.out.println(p.isStraight());
                System.out.println(p.isPoker());
                System.out.println(p.isFullHouse());
                System.out.println(p.isFlush());
                System.out.println(p.isThree());
                System.out.println(p.isTwoPairs());
                System.out.println(p.isPair());
            }
        }
    }
    
    public static class Player implements Comparable<Player> {

        List<Card> cards = new ArrayList<Card>(2);
        List<Card> cards_col = new ArrayList<Card>(2);
        public String toString()
        {
            return cards.toString()+" || "+cards_col.toString();
        }
        
        
        public boolean isThree()
        {
            return getMax3(cards)!=null;
        }
        public boolean isTwoPairs()
        {
            VALUE val = getMax2(cards, null);
            if(val==null)
                return false;
            return getMax2(cards, val)!=null;
        }
        public boolean isPair()
        {
            return getMax2(cards, null)!=null;
        }

    public  boolean isRoFlush()
    {
        next_five:
        for(int i=0;i<3;i++)
        {
            for(int j=1;j<5;j++)
            {
                if(!cards_col.get(j+i-1).val.isNext(cards_col.get(j+i).val)
                   || cards_col.get(j+i-1).col!=cards_col.get(j+i).col)
                    continue next_five;
            }
            return true;
        }
        return false;
    }
    public  boolean isStraight()
    {
        next_five:
        for(int i=0;i<3;i++)
        {
            for(int j=1;j<5;j++)
            {
                if(!cards.get(j+i-1).val.isNext(cards.get(j+i).val))
                    continue next_five;
            }
            return true;
        }
        return false;
    }
    public boolean isPoker()
    {
        next_five:
        for(int i=0;i<4;i++)
        {
            for(int j=1;j<4;j++)
            {throw new UnsupportedOperationException("Not supported yet.");
                if(cards.get(j+i-1).val!=(cards.get(j+i).val))
                    continue next_five;
            }
            return true;
        }
        return false;
    }
    
    public boolean isFullHouse()
    {
        VALUE trojce = getMax3(cards);
        if(trojce==null)
            return false;
        return getMax2(cards, trojce)!=null;
    }
    
    public boolean isFlush()
    {
        next_five:
        for(int i=0;i<3;i++)
        {
            for(int j=1;j<5;j++)
            {
                if(cards_col.get(j+i-1).col!=(cards_col.get(j+i).col))
                    continue next_five;
            }
            return true;
        }
        return false;
    }

        public int compareTo(Player arg0) {
            if(isRoFlush())
            {
                if(arg0.isRoFlush())
                {
                    
                }
            }
            return 0;
        }
        
    }

    public static class Card {

        VALUE val;
        COLOR col;

        public static Card fromStr(String in) {
            Card c = new Card();
            c.val = VALUE.fromStr(in.substring(0, 1));
            c.col = COLOR.fromStr(in.substring(1, 2));
            return c;
        }

        public String toString() {
            return "{" + val + "" + col + "}";
        }
    }
    
    public static VALUE getMax3(List<Card> crds)
    {
        for(int i=crds.size()-1;i>=2;i--)
        {
            if(crds.get(i).val==crds.get(i-1).val
                    && crds.get(i).val==crds.get(i-2).val)
                return crds.get(i).val;
        }
        return null;
    }
    public static VALUE getMax2(List<Card> crds, VALUE except)
    {
        for(int i=crds.size()-1;i>=2;i--)
        {
            if(crds.get(i).val==except)
                continue;
            if(crds.get(i).val==crds.get(i-1).val)
                return crds.get(i).val;
        }
        return null;
    }
    
    public static enum COLOR {

        c("c"), d("d"), h("h"), s("s");
        String ident;

        private COLOR(String ident) {
            this.ident = ident;
        }

        public static COLOR fromStr(String in) {
            for (COLOR c : COLOR.values()) {
                if (c.ident.equals(in)) {
                    return c;
                }
            }
            return null;
        }

        public String toString() {
            return ident;
        }
    }

    public static enum VALUE {

        _A("A"),
        _2("2"),
        _3("3"),
        _4("4"),
        _5("5"),
        _6("6"),
        _7("7"),
        _8("8"),
        _9("9"),
        _X("X"),
        _J("J"),
        _Q("Q"),
        _K("K");
        String ident;

        boolean isNext(VALUE s)
        {
            return (ordinal()+1==s.ordinal()) || (this==_K && s==_A);
        }
        
        private VALUE(String ident) {
            this.ident = ident;
        }

        public static VALUE fromStr(String in) {
            for (VALUE c : VALUE.values()) {
                if (c.ident.equals(in)) {
                    return c;
                }
            }
            return null;
        }

        public String toString() {
            return ident;
        }
    }

    
    

;
}
